/*
 * Savings.java
 * KIDware (206) 721-2556
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;

public class Savings extends JFrame 
{
	
	static JLabel depositLabel = new JLabel();
	static JLabel interestLabel = new JLabel();
	static JLabel monthsLabel = new JLabel();
	static JLabel finalLabel = new JLabel();
	static JTextField depositTextField = new JTextField();
	static JTextField interestTextField = new JTextField();
	static JTextField monthsTextField = new JTextField();
	static JTextField finalTextField = new JTextField();
	static JButton calculateButton = new JButton();
	static JButton exitButton = new JButton();
	static JButton clearButton = new JButton();

  public static void main(String args[]) 
  {
  	//construct frame
    new Savings().show();
  }

  public Savings() 
  {
  	// code to build the form
    setTitle("Savings Account");
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls (establish event methods)
    GridBagConstraints gridConstraints = new GridBagConstraints();
    depositLabel.setText("Monthly Deposit");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    getContentPane().add(depositLabel, gridConstraints);
    interestLabel.setText("Yearly Interest");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(interestLabel, gridConstraints);
    monthsLabel.setText("Number of Months");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    getContentPane().add(monthsLabel, gridConstraints);
    finalLabel.setText("Final Balance");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 3;
    getContentPane().add(finalLabel, gridConstraints);

    depositTextField.setText("");
    depositTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 0;
    getContentPane().add(depositTextField, gridConstraints);
    depositTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		depositTextFieldActionPerformed(e);
    	}
    });

    interestTextField.setText("");
    interestTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 1;
    getContentPane().add(interestTextField, gridConstraints);
    interestTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		interestTextFieldActionPerformed(e);
    	}
    });

    monthsTextField.setText("");
    monthsTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 2;
    getContentPane().add(monthsTextField, gridConstraints);
    monthsTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		monthsTextFieldActionPerformed(e);
    	}
    });

    finalTextField.setText("");
    finalTextField.setFocusable(true);
    finalTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 3;
    getContentPane().add(finalTextField, gridConstraints);
    finalTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		finalTextFieldActionPerformed(e);
    	}
    });
   
    calculateButton.setText("Calculate");
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 4;
    getContentPane().add(calculateButton, gridConstraints);
    calculateButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		calculateButtonActionPerformed(e);
    	}
    });
    exitButton.setText("Exit");
    exitButton.setFocusable(false);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 5;
    getContentPane().add(exitButton, gridConstraints);
    exitButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		exitButtonActionPerformed(e);
    	}
    });
    clearButton.setText("Clear");
    clearButton.setFocusable(false);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 4;
    getContentPane().add(clearButton, gridConstraints);
    clearButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		clearButtonActionPerformed(e);
    	}
    });
    pack();
	}
	
	private void depositTextFieldActionPerformed(ActionEvent e)
	{
		depositTextField.transferFocus();
	}
	
	private void interestTextFieldActionPerformed(ActionEvent e)
	{
		interestTextField.transferFocus();
	}
	
	private void monthsTextFieldActionPerformed(ActionEvent e)
	{
		monthsTextField.transferFocus();
	}

	private void finalTextFieldActionPerformed(ActionEvent e)
	{
		finalTextField.transferFocus();
	}
	
	private void calculateButtonActionPerformed(ActionEvent e)
	{
		double deposit;
		double interest;
		double months;
		double finalBalance;
		double monthlyInterest;
    double finalCompute, intChange;
    int intDirection;
		// make sure each is a valid number
  	// Determine which box is blank
    // Compute that missing value and put in text box
    if (depositTextField.getText().trim().equals(""))
    {
      // deposit missing
    	// read other values from text fields
    	// make sure valid before computing
			if (!validateDecimalNumber(monthsTextField) || !validateDecimalNumber(interestTextField) || !validateDecimalNumber(finalTextField))
			{
				// if one or more fields not valid number, then exit method
				return;
			}
    	interest = Double.valueOf(interestTextField.getText()).doubleValue();
    	monthlyInterest = interest / 1200;
    	months = Double.valueOf(monthsTextField.getText()).doubleValue();
    	finalBalance = Double.valueOf(finalTextField.getText()).doubleValue();
      if (interest == 0)
      {
      	deposit = finalBalance / months;
      }
      else
      {
      	deposit = finalBalance / ((Math.pow((1 + monthlyInterest),  months) - 1) / monthlyInterest);
      }
    	depositTextField.setText(new DecimalFormat("0.00").format(deposit));
    }
    else if (interestTextField.getText().trim().equals(""))
    {
    	// interest missing - requires iterative solution
      // intChange is how much we change interest each step
      // intDirection is direction (+ or -) we change interest
    	// read other values from text fields
    	// make sure valid before computing
			if (!validateDecimalNumber(monthsTextField) || !validateDecimalNumber(depositTextField) || !validateDecimalNumber(finalTextField))
			{
				// if one or more fields not valid number, then exit method
				return;
			}
    	deposit = Double.valueOf(depositTextField.getText()).doubleValue();
    	months = Double.valueOf(monthsTextField.getText()).doubleValue();
    	finalBalance = Double.valueOf(finalTextField.getText()).doubleValue();
      interest = 0;
      intChange = 1;
      intDirection = 1;
      do
      {
      	interest += intDirection * intChange;
        monthlyInterest = interest / 1200;
        finalCompute = deposit * (Math.pow((1 + monthlyInterest), months) - 1) / monthlyInterest;
        if (intDirection == 1)
        {
          if (finalCompute > finalBalance)
          {
            intDirection = -1;
            intChange /= 10;
          }
        }
        else
        {
          if (finalCompute < finalBalance)
          {
            intDirection = 1;
            intChange /= 10;
          }
        }
      }
      while (Math.abs(finalCompute - finalBalance) >= 0.005);
    	interestTextField.setText(new DecimalFormat("0.00").format(interest));
    }
    else if (monthsTextField.getText().trim().equals(""))
    {
      // months missing
    	// read other values from text fields
    	// make sure valid before computing
			if (!validateDecimalNumber(depositTextField) || !validateDecimalNumber(interestTextField) || !validateDecimalNumber(finalTextField))
			{
				// if one or more fields not valid number, then exit method
				return;
			}
    	deposit = Double.valueOf(depositTextField.getText()).doubleValue();
    	interest = Double.valueOf(interestTextField.getText()).doubleValue();
    	monthlyInterest = interest / 1200;
    	finalBalance = Double.valueOf(finalTextField.getText()).doubleValue();
      if (interest == 0)
      {
        months = finalBalance / deposit;
      }
      else
      {
        months = Math.log(finalBalance * monthlyInterest / deposit + 1) / Math.log(1 + monthlyInterest);
      }
    	monthsTextField.setText(new DecimalFormat("0.00").format(months));
    }
    else if (finalTextField.getText().trim().equals(""))
    {
     	// Final value missing
      // compute final value and put in text field;
    	// read other values from text fields
    	// make sure valid before computing
			if (!validateDecimalNumber(monthsTextField) || !validateDecimalNumber(interestTextField) || !validateDecimalNumber(depositTextField))
			{
				// if one or more fields not valid number, then exit method
				return;
			}
    	deposit = Double.valueOf(depositTextField.getText()).doubleValue();
    	interest = Double.valueOf(interestTextField.getText()).doubleValue();
    	monthlyInterest = interest / 1200;
    	months = Double.valueOf(monthsTextField.getText()).doubleValue();
    	if (interest == 0)
    	{ 
      	finalBalance = deposit * months;
    	}
    	else
    	{
    		finalBalance = deposit * (Math.pow((1 + monthlyInterest), months) - 1) / monthlyInterest;
    	}
    	finalTextField.setText(new DecimalFormat("0.00").format(finalBalance));
  	}
  	
	}

		
	private void exitButtonActionPerformed(ActionEvent e)
	{
  	System.exit(0);
	}
	
	private void clearButtonActionPerformed(ActionEvent e)
	{
  	// clear text fields
  	depositTextField.setText("");
  	interestTextField.setText("");
  	monthsTextField.setText("");
  	finalTextField.setText("");
  	depositTextField.requestFocus();
	}
	
  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }

	public boolean validateDecimalNumber(JTextField tf)
	{
		// checks to see if text field contains
		// valid decimal number with only digits and a single decimal point
		String s = tf.getText().trim();
		boolean hasDecimal = false;
		boolean valid = true;
		if (s.length() == 0)
		{
			valid = false;
		}
		else
		{
			for (int i = 0; i < s.length(); i++)
			{
				char c = s.charAt(i);
				if (c >= '0' && c <= '9')
				{
					continue;
				}
				else if (c == '.' && !hasDecimal)
				{
					hasDecimal = true;
				}
				else
				{
					// invalid character found
					valid = false;
				}
			}
		}
		if (valid)
		{
			tf.setText(s);
		}
		else
		{
			tf.setText("");
			tf.requestFocus();
		}
		return (valid);
	}
	
}
