/*
 * Password.java
 * KIDware (206) 721-2556
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Password extends JFrame 
{
  static JLabel passwordLabel = new JLabel();
  static JPasswordField inputPasswordField = new JPasswordField();
  static JButton validButton = new JButton();
  static JButton exitButton = new JButton();
	
  public static void main(String args[]) 
  {
  	//construct frame
    new Password().show();
    System.out.println(inputPasswordField.getText());
  }

  public Password() 
  {
  	// code to build the form
    setTitle("Password Validation");
    setResizable(false);
    getContentPane().setBackground(Color.YELLOW);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());

    // position controls
    GridBagConstraints gridConstraints;
    passwordLabel.setText("Please Enter Your Password:");
    passwordLabel.setOpaque(true);
    passwordLabel.setBackground(Color.white);
  	passwordLabel.setFont(new Font("Arial", Font.BOLD, 14));
    passwordLabel.setBorder(BorderFactory.createLoweredBevelBorder());
    passwordLabel.setHorizontalAlignment(SwingConstants.CENTER);
    gridConstraints = new GridBagConstraints();
    gridConstraints.ipadx = 30;
    gridConstraints.ipady = 20;
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(5, 20, 5, 20);
    getContentPane().add(passwordLabel, gridConstraints);
    
    inputPasswordField.setText("");
  	inputPasswordField.setFont(new Font("Arial", Font.PLAIN, 14));
    inputPasswordField.setColumns(15);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(inputPasswordField, gridConstraints);
    inputPasswordField.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e) 
      {
        inputPasswordFieldActionPerformed(e);
      }
    });
    
    validButton.setText("Validate");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    getContentPane().add(validButton, gridConstraints);
    validButton.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        validButtonActionPerformed(e);
      }
    });

    exitButton.setText("Exit");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 3;
    getContentPane().add(exitButton, gridConstraints);
    exitButton.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        exitButtonActionPerformed(e);
      }
    });

    pack();
  	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());
  }
	private void inputPasswordFieldActionPerformed(ActionEvent e) 
	{
    validButton.doClick();
  }

  private void validButtonActionPerformed(ActionEvent e) 
  {
	  final String THEPASSWORD = "LetMeIn";

    //This procedure checks the input password
    int response;
    if (inputPasswordField.getText().equals(THEPASSWORD))
    {
      // If correct, display message box
      JOptionPane.showConfirmDialog(null, "You've passed security!", "Access Granted", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE);
    }
    else
    {
      // If incorrect, give option to try again
      response = JOptionPane.showConfirmDialog(null, "Incorrect password - Try Again?", "Access Denied", JOptionPane.YES_NO_OPTION, JOptionPane.ERROR_MESSAGE);
      if (response == JOptionPane.YES_OPTION)
      {
        inputPasswordField.setText("");
        inputPasswordField.requestFocus();
      }
      else
      {
        exitButton.doClick();
      }
    }
  }
  
  private void exitButtonActionPerformed(ActionEvent e) 
  {
    System.exit(0);
  }

  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }

}
