/*
 * Flight.java
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Flight extends JFrame 
{
  static JLabel citiesLabel = new JLabel();
  static JList citiesList = new JList();
  static JScrollPane citiesScrollPane = new JScrollPane();
  static JLabel seatLabel = new JLabel();
  static JComboBox seatComboBox = new JComboBox();
  static JLabel mealLabel = new JLabel();
  static JComboBox mealComboBox = new JComboBox();
  static JButton assignButton = new JButton();
  static JButton exitButton = new JButton();

  public static void main(String args[]) 
  {
  	// construct frame
    new Flight().show();

    // populate cities
    DefaultListModel citiesListModel = new DefaultListModel();
    citiesListModel.addElement("San Diego");
    citiesListModel.addElement("Los Angeles");
    citiesListModel.addElement("Orange County");
    citiesListModel.addElement("Ontario");
    citiesListModel.addElement("Bakersfield");
    citiesListModel.addElement("Oakland");
    citiesListModel.addElement("Sacramento");
    citiesListModel.addElement("San Jose");
    citiesListModel.addElement("San Francisco");
    citiesListModel.addElement("Eureka");
    citiesListModel.addElement("Eugene");
    citiesListModel.addElement("Portland");
    citiesListModel.addElement("Spokane");
    citiesListModel.addElement("Seattle");
    citiesList.setModel(citiesListModel);
    citiesList.setSelectedIndex(0);

    // populate seats
    seatComboBox.addItem("Aisle");
    seatComboBox.addItem("Middle");
    seatComboBox.addItem("Window");
    seatComboBox.setSelectedIndex(0);

    // meals
    mealComboBox.addItem("Chicken");
    mealComboBox.addItem("Mystery Meat");
    mealComboBox.addItem("Kosher");
    mealComboBox.addItem("Vegetarian");
    mealComboBox.addItem("Fruit Plate");
    mealComboBox.setSelectedItem("No Preference");
  
  }
  
  public Flight() 
  {
    // create frame
    setTitle("Flight Planner");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
        exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls
    
    GridBagConstraints gridConstraints;

    citiesLabel.setText("Destination City");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(10, 0, 0, 0);
    getContentPane().add(citiesLabel, gridConstraints);
    citiesScrollPane.setPreferredSize(new Dimension(150, 100));
    citiesScrollPane.setViewportView(citiesList);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    getContentPane().add(citiesScrollPane, gridConstraints);
    
    seatLabel.setText("Seat Location");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(10, 0, 0, 0);
    getContentPane().add(seatLabel, gridConstraints);
    seatComboBox.setBackground(Color.WHITE);
    seatComboBox.setPreferredSize(new Dimension(100, 25));
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(10, 10, 0, 10);
    gridConstraints.anchor = GridBagConstraints.NORTH;
    getContentPane().add(seatComboBox, gridConstraints);

    mealLabel.setText("Meal Preference");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(10, 0, 0, 0);
    getContentPane().add(mealLabel, gridConstraints);
    mealComboBox.setEditable(true);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(10, 10, 0, 10);
    gridConstraints.anchor = GridBagConstraints.NORTH;
    getContentPane().add(mealComboBox, gridConstraints);

    assignButton.setText("Assign");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 2;
    gridConstraints.insets = new Insets(0, 0, 10, 0);
    getContentPane().add(assignButton, gridConstraints);
    assignButton.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        assignButtonActionPerformed(e);
      }
    });


    exitButton.setText("Exit");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 2;
    gridConstraints.insets = new Insets(0, 0, 10, 0);
    getContentPane().add(exitButton, gridConstraints);
    exitButton.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        exitButtonActionPerformed(e);
      }
    });
 
    pack();
   	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());

	}
  
  private void assignButtonActionPerformed(ActionEvent e) 
  {
    // Build message box that gives your assignment
    String message;
    message = "Destination: " + citiesList.getSelectedValue() + "\n";
    message += "Seat Location: " + seatComboBox.getSelectedItem() + "\n";
    message += "Meal: " + mealComboBox.getSelectedItem() + "\n";
    JOptionPane.showConfirmDialog(null, message, "Your Assignment", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
  }


  private void exitButtonActionPerformed(ActionEvent e) 
  {
    System.exit(0);
  }
  
  private void exitForm(WindowEvent e) 
  {
    System.exit(0);
  }
  
}
