/*
 * ComboProblem.java
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ComboProblem extends JFrame 
{
  
  static JComboBox exampleComboBox = new JComboBox();
  static JButton processButton = new JButton();

  public static void main(String args[]) 
  {
    // construct frame
    new ComboProblem().show();
    // Add a few words to start with
    exampleComboBox.addItem("Learn Java");
    exampleComboBox.addItem("Combo Box");
    exampleComboBox.addItem("Programmer");
    exampleComboBox.addItem("Class 3");
    exampleComboBox.addItem("List Box Control");
    exampleComboBox.addItem("Event-driven");

  }

  public ComboProblem() 
  {
    // frame constructor
    setTitle("Combo Box Problem");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
        exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());

    // position controls
    GridBagConstraints gridConstraints;
    exampleComboBox.setEditable(true);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    getContentPane().add(exampleComboBox, gridConstraints);
    exampleComboBox.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        exampleComboBoxActionPerformed(e);
      }
    });
    processButton.setText("Process Choice");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(processButton, gridConstraints);
    processButton.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        processButtonActionPerformed(e);
      }
    });
    
    pack();
   	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());
  }
  
  private void exampleComboBoxActionPerformed(ActionEvent e)
  {
  	processButton.doClick();
  }

  private void processButtonActionPerformed(ActionEvent e)
  {
  	// If in list - exit method
    if (exampleComboBox.getItemCount() != 0)
    {
      for (int i = 0; i < exampleComboBox.getItemCount(); i++)
      {
      	if (exampleComboBox.getSelectedItem().toString().equals(exampleComboBox.getItemAt(i).toString()))
      	{
          return;
        }
      }
  	}
    // If not found, add to list box
    exampleComboBox.addItem(exampleComboBox.getSelectedItem());
  }

  private void exitForm(WindowEvent e) 
  {
    System.exit(0);
  }
}
