/*
 * NumberGuess.java
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;

public class NumberGuess extends JFrame 
{
	
	static JTextField guessTextField = new JTextField();
	static JTextField lowTextField = new JTextField();
	static JTextField highTextField = new JTextField();
	static JScrollBar guessScrollBar = new JScrollBar();
	static JButton checkButton = new JButton();
	
  static int theNumber;
  static int myGuess;
  static Random myRandom = new Random();

  public static void main(String args[]) 
  {
  	// construct frame
    new NumberGuess().show();
  }
  
  public NumberGuess() 
  {
    // create frame
    setTitle("Number Guess Problem");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
        exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls
    Font myFont = new Font("Arial", Font.BOLD, 24);
   
    GridBagConstraints gridConstraints;
    guessTextField.setText("50");
    guessTextField.setColumns(3);
    guessTextField.setFont(myFont);
    guessTextField.setEditable(false);
    guessTextField.setBackground(Color.WHITE);
    guessTextField.setForeground(Color.RED);
    guessTextField.setHorizontalAlignment(SwingConstants.CENTER);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(10, 0, 10, 0);
    getContentPane().add(guessTextField, gridConstraints);
    
   
    lowTextField.setText("1");
    lowTextField.setColumns(3);
    lowTextField.setFont(myFont);
    lowTextField.setEditable(false);
    lowTextField.setBackground(Color.WHITE);
    lowTextField.setForeground(Color.BLUE);
    lowTextField.setHorizontalAlignment(SwingConstants.CENTER);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(0, 10, 0, 10);
    getContentPane().add(lowTextField, gridConstraints);
    
    highTextField.setText("100");
    highTextField.setColumns(3);
    highTextField.setFont(myFont);
    highTextField.setEditable(false);
    highTextField.setBackground(Color.WHITE);
    highTextField.setForeground(Color.BLUE);
    highTextField.setHorizontalAlignment(SwingConstants.CENTER);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(0, 10, 0, 10);
    getContentPane().add(highTextField, gridConstraints);
    
    guessScrollBar.setPreferredSize(new Dimension (200, 30));
    guessScrollBar.setEnabled(false);
    guessScrollBar.setMinimum(1);
    guessScrollBar.setMaximum(100 + guessScrollBar.getVisibleAmount());
    guessScrollBar.setUnitIncrement(1);
    guessScrollBar.setBlockIncrement(10);
    guessScrollBar.setValue(50);
    guessScrollBar.setOrientation(JScrollBar.HORIZONTAL);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    getContentPane().add(guessScrollBar, gridConstraints);
    guessScrollBar.addAdjustmentListener(new AdjustmentListener()
    {
      public void adjustmentValueChanged(AdjustmentEvent e) 
      {
        guessScrollBarAdjustmentValueChanged(e);
      }
    });

    checkButton.setText("Pick Number");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 2;
    gridConstraints.insets = new Insets(10, 0, 10, 0);
    getContentPane().add(checkButton, gridConstraints);
    checkButton.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        checkButtonActionPerformed(e);
      }
    });
 
    pack();
   	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());

	}
  
  
  private void guessScrollBarAdjustmentValueChanged(AdjustmentEvent e)
  {
		// Read myGuess and display it
    myGuess = guessScrollBar.getValue();
    guessTextField.setText(String.valueOf(myGuess));

  }

  private void checkButtonActionPerformed(ActionEvent e) 
  {
		if (checkButton.getText().equals("Pick Number"))
		{
     	// Get new number and set controls
      theNumber = myRandom.nextInt(100) + 1;
      guessScrollBar.setMinimum(1);
      lowTextField.setText("1");
      guessScrollBar.setMaximum(100 + guessScrollBar.getVisibleAmount());
      highTextField.setText("100");
      guessScrollBar.setValue(50);
      guessScrollBar.setEnabled(true);
      checkButton.setText("Check Guess");
    }
    else
    {
    	if (myGuess == theNumber)
    	{
    		// Correct guess
        guessScrollBar.setEnabled(false);
        lowTextField.setText("");
        highTextField.setText("");
        checkButton.setText("Pick Number");
      }
      else if (myGuess < theNumber)
      {
        // Guess is too low
        guessScrollBar.setValue(guessScrollBar.getValue() + 1);
        guessScrollBar.setMinimum(guessScrollBar.getValue());
        lowTextField.setText(String.valueOf(guessScrollBar.getValue()));
      }
      else
      {
        // Guess is too high
        guessScrollBar.setValue(guessScrollBar.getValue() - 1);
        guessScrollBar.setMaximum(guessScrollBar.getValue() + guessScrollBar.getVisibleAmount());
        highTextField.setText(String.valueOf(guessScrollBar.getValue()));
      }
    }
    myGuess = guessScrollBar.getValue();
    guessTextField.setText(String.valueOf(myGuess));

	}


  private void exitForm(WindowEvent e) 
  {
    System.exit(0);
  }
  
}
